#ifndef DEMARATHON_H
#define DEMARATHON_H

#ifdef __cplusplus
extern "C" {
#endif

struct marathon
{
  demo demo;
  char *mapname;
  char *filename;
  char *time;
};

struct pak_header
{
  char sig[4];
  unsigned int doffs;
  unsigned int dlen;
};

struct pak_dirent
{
  char filename[56];
  unsigned int fpos;
  unsigned int flen;
};

extern int make_marathon(demo *dem,
                         struct marathon *marathon,
                         int max,
                         int *count);
extern int filter_demos(struct marathon *m, int count);
extern int make_pak(char *pakname, struct marathon *m, int count);

extern char *pak_error(int errcode);
extern char *filter_error(int errcode);
extern char *marathon_error(int errcode);
extern char *demarathon_error(int errcode);

#define DEMARATHON_OK              0

#define MARATHON_OK                DEMARATHON_OK
#define MARATHON_EBASE             100
#define MARATHON_NONUNIQUE_DEMO    100

#define FILTER_OK                  DEMARATHON_OK
#define FILTER_EBASE               200

#define PAK_OK                     DEMARATHON_OK
#define PAK_EBASE                  300
#define PAK_FILE_EXISTS            300
#define PAK_CANNOT_OPEN            301
#define PAK_NO_MEMORY              302
#define PAK_CANNOT_WRITE           303
#define PAK_CORRUPT_DEMO           304

#ifdef __cplusplus
}
#endif

#endif // DEMARATHON_H
